﻿package {
	import flash.display.MovieClip;
	import flash.geom.Point;
	
	
	/**
	 * 敵クラス
	 */
	public class Enemy extends MovieClip {
		
		var myShip:MovieClip;	//自機MCへの参照
		var ground:MovieClip;	//地形MCへの参照
		
		var nodeMgr:NodeMgr;	//ノード管理クラス
		
		var moveSpd:uint = 7;	//移動速度
		var vx:Number = 0;		//移動ベクトル
		var vy:Number = 0;
		
		
		/**
		 * コンストラクタ
		 * @param	myShip		自機MCへの参照
		 * @param	ground		地形MCへの参照
		 * @param	nodeList	ノードMC配列への参照
		 */
		public function Enemy(myShip:MovieClip, ground:MovieClip, nodeList:Array)
		{
			this.myShip = myShip;
			this.ground = ground;
			
			nodeMgr=  new NodeMgr(nodeList);
		}
		
		/**
		 * 	フレーム関数
		 */
		public function frameFunc():void
		{
			checkNode();
			setVector();
			move();
		}
		
		/**
		 * 敵の速度を変更
		 * @param	spd		速度
		 */
		public function setSpeed(spd:Number):void
		{
			moveSpd = spd;
		}
		
		/**
		 * 自機と敵のいるノードを更新
		 */
		function checkNode():void
		{
			nodeMgr.setEnemyNode(this.x, this.y);
			nodeMgr.setMyShipNode(myShip.x, myShip.y);
		}
		
		
		/**
		 * 移動ベクトルを設定
		 */
		function setVector():void
		{
			//移動先の座標を取得
			var targetPt:Point = nodeMgr.getNextNodePoint();
			
			//Nullだったら自機を移動先に設定
			if (targetPt == null) {
				targetPt = new Point(myShip.x, myShip.y);
			}
			
			var rot:Number = Math.atan2(targetPt.y - this.y, targetPt.x - this.x);
			
			vx = Math.cos(rot) * moveSpd;
			vy = Math.sin(rot) * moveSpd;	
		}
		
		/**
		 * 移動
		 */
		function move():void
		{
			var lastX:Number = this.x;
			var lastY:Number = this.y;
			
			//Ｘ座標を移動
			this.x += vx;
			if (ground.hitTestPoint(this.x, this.y, true)) {
				this.x = lastX;
			}
			else {
				lastX = this.x;
			}
						
			
			//Ｙ座標を移動
			this.y += vy;
			if (ground.hitTestPoint(this.x, this.y, true)) {
				this.y = lastY;
			}
		}
	}
}