﻿package {
	import flash.geom.Point;
	
	/**
	 * 敵の移動処理クラス
	 */
	public class NodeMgr {
		var nodeList:Array;	//オーサリング環境上の各ノードMCへの参照

		//ノードの関係を表す二次配列
		var nodeMatrix:Array = new Array(
				new Array(0, 1, 1, 1, 1, 1, 1, 1),
				new Array(0, 1, 2, 2, 2, 7, 7, 7),
				new Array(1, 1, 2, 3, 3, 1, 1, 1),
				new Array(2, 2, 2, 3, 4, 4, 2, 2),
				new Array(3, 3, 3, 3, 4, 5, 5, 5),
				new Array(6, 6, 6, 4, 4, 5, 6, 6),
				new Array(7, 7, 7, 7, 5, 5, 6, 7),
				new Array(1, 1, 1, 1, 6, 6, 6, 7)
			);
		
		var enemyNodeIndex:uint = 0;	//今敵がいるノードの番号
		var myShipNodeIndex:uint = 0;	//今自機がいるノードの番号
		
		/**
		 * コンストラクタ
		 * @param	nodeList	各ノードMCへの産業
		 */
		function NodeMgr(nodeList:Array)
		{
			this.nodeList = nodeList;
			var i:uint;
			
			for (i=0; i<nodeList.length; i++) {
				nodeList[i].nodeNumber.text = i;//ノードの番号を表示
				nodeList[i].alpha = 0;			//ノードを見えなくする				
			}
		}
		
		/**
		 * 敵が今いるノードを取得
		 * @param	x	X座標
		 * @param	y	Y座標
		 */
		public function setEnemyNode(x:Number, y:Number):void
		{
			enemyNodeIndex = getHitNodeIndex(x, y, enemyNodeIndex);
		}
		
		/**
		 * 自機が今いるノードを取得
		 * @param	x	X座標
		 * @param	y	Y座標
		 */
		public function setMyShipNode(x:Number, y:Number):void
		{
			myShipNodeIndex = getHitNodeIndex(x, y, myShipNodeIndex);
		}
		
		
		/**
		 * 敵が向かうべきノードの座標を返す
		 * @return	ノードのPoint座標　(敵と自機のいるノードが同じならばNullを返す)
		 */
		public function getNextNodePoint():Point
		{
			if (enemyNodeIndex == myShipNodeIndex) {
				return null;
			}
			
			var index:uint = nodeMatrix[enemyNodeIndex][myShipNodeIndex];
			//trace("e:" + enemyNodeIndex + " m:" + myShipNodeIndex + " g:" + index);
			var pt:Point = new Point(nodeList[index].x, nodeList[index].y);
			
			return pt;
		}
		
		/**
		 * XY座標上のノードを取得
		 * @param	x
		 * @param	y
		 * @param	nowIndex	更新前の今のノード
		 * @return	ノード番号
		 */
		function getHitNodeIndex(x:Number, y:Number, nowIndex):uint
		{
			var i:uint;
			
			for (i=0; i<nodeList.length; i++) {
				if (nodeList[i].hitTestPoint(x, y, false)) {
					return i;
				}
			}
			return nowIndex;
		}		
		
	}
}